// -*- MaTX -*-

// sim00016.mm: tmd00016.{h,mm} ΥƥȤΤΥߥ졼
//
//   Originally written by KIYOTA Hiromitsu <1999/02/18>
//   Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
//
// RCS: $Id: sim00016.mm,v 1.4 1999/05/31 03:42:31 kiyota Exp $

// Local options
//#define NOPLOT
//#define MULTIPLOT

// These are required #definitions.
#define TMD00016_USER_H "sim00016.h"
#define TMD00016_USER_MM "sim00016.mm"

// TMD00016_USER_H  #include 롣
#include "tmd00016.h"


Func void
main()
{
  Matrix TC, XC, UC;
  Matrix link_eqs();
#ifndef NOPLOT
  List names;
  Integer i;
#ifdef MULTIPLOT
  Integer hmultiplot(...) require "hplot.mm";
#endif /* MULTIPLOT */
#endif /* ! NOPLOT */

//  init_tmd00016(1); // Υߥ졼(not given)
  init_tmd00016(0); // Υߥ졼

  {TC, XC, UC} = Ode45Auto(0.0, 0.02,
#ifndef TMD00016_USER_DIFF
			   [4000]',
#else /* TMD00016_USER_DIFF */
			   [[4000],
			    [0.0, 0.0]]', // ưŪν
#endif /* ! TMD00016_USER_DIFF */
			   diff_tmd00016, link_eqs, 1e-12);
  print [[TC][XC][UC]] >> "sim.mat";

#ifndef NOPLOT
  names = {"x(=Pm)", // XC
#ifdef TMD00016_USER_DIFF
	   "(x2)", "(x3)",  // ưŪξ
#endif /* TMD00016_USER_DIFF */
	   "u1(=theta)", "u2(=omega)", "y(=Qc)" // UC
	   };

#ifndef MULTIPLOT
   for (i = 1; i <= length(names); ++i)
     {
       if (names(i, String) == "-") { continue; }
       mgplot_grid(i, 1);
       mgplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
     }
#else /* MULTIPLOT */
  hmultiplot(1, TC, [[XC][UC]], names);
#endif /* ! MULTIPLOT */
  pause;
#endif /* ! NOPLOT */
}


Func Matrix
link_eqs(t, xx)
     Real t;
     Matrix xx;
{
  Matrix uy;
  static Integer running;
  static Matrix u;
  Matrix x, y;

  if (running == 0) // ߥ졼󳫻ϻ
    {
      uy = Z(TMD00016_DIM_ALL_IOS,1);
      u = chop_input_tmd00016(uy);
      running = 1;
    }

  x = chop_state_tmd00016(xx);
  y = output_tmd00016(t, x, u);

  u(1) /* theta */ = PI/3; // 60 deg
  u(2) /* omega */ = 10; /* rad/s */

  uy = [[u]
	[y]];
  return uy;
}


#ifdef TMD00016_USER_DIFF
// ߡưŪ
Func Matrix
TMD00016_USER_DIFF(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, z, u, y; // z ϤǤϴ¬ξ֤ʤ

  x = chop_state_tmd00016(xx);
  z = chop_other_state_tmd00016(xx);
  u = chop_input_tmd00016(uu);
  y = output_tmd00016(t, x, u);
  // etc.

  return [1.0, -1.0]'; // ߡΤøʥʥߥ ;-)
}
#endif /* TMD00016_USER_DIFF */
