/* -*- MaTX -*-
 *
 * tmd00016.mm: TMD No. tmd00016 ư֥󥸥Τε۵ϤΥǥ
 *
 *  Originally written by KIYOTA Hiromitsu <1999/02/18>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00016.mm,v 1.7 1999/06/29 03:53:53 kiyota Exp $
 */

#ifndef _TMD00016_MM
#define _TMD00016_MM

#ifndef TMD_EXTERN
#define TMD_EXTERN extern
#endif /* ! TMD_EXTERN */
#include "tmd00016.h"

// some definitions for local alist
#define _TMD_LALIST {"_tmd00016"}
#define _TMD_LIN_FLAG "linear_flag"

// just for simplicity... B)
#define tmd16(var) tmd00016(var)

Func void
init_tmd00016(linear_flag, params_flag, ...)
     Integer linear_flag, params_flag;
{
#ifndef TMD00016_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00016_DISABLE_HALIST */

  switch (nargs)
    {
    case 2:
      break;
    case 0:
      linear_flag = 0; // ǥե: ǥ
    case 1:
      params_flag = 0; // ǥե: ѥ᡼̤
      break;
    default:
      error("init_tmd00016(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }

  // ()Υե饰
#ifndef TMD00016_DISABLE_HALIST
  if (halist({_TMD_LALIST, "exists"}) == {})  // if not exist
    {
      halist({_TMD_LALIST, "clear"});  // new alist
    }
  halist(_TMD_LALIST, {{_TMD_LIN_FLAG, linear_flag}});
#else /* TMD00016_DISABLE_HALIST */
  tmd00016_flag = linear_flag;
#endif /* ! TMD00016_DISABLE_HALIST */

  if (params_flag == 0)
    {
      tmd16(P0) = 101325.0; /* Pa */	// 絤
      tmd16(T0) = 298.15; /* K */	// 絤
      tmd16(Tm) = 313.15; /* K */	// ޥ˥ۡɶ
      tmd16(At0) = 2.8e-3; /* m^2 */	// åȥ
      tmd16(Vm) = 1.97e-3; /* m^3 */	// ޥ˥ۡ
      tmd16(Vc) = 5.5e-4; /* m^3 */	// 
      tmd16(R) = 287.1; /* J/kgK */	// 
      tmd16(kappa) = 1.4; /* */		// Ǯ

      // Kt = a0 + a1*omega + a2*omega^2 + a3*Pm
      tmd16(a0) = 1.0; /* */		// ѸΨ˴ؤ(not specified)
      tmd16(a1) = 1.0; /* */		// ditto
      tmd16(a2) = 1.0; /* */		// ditto
      tmd16(a3) = 1.0; /* */		// ditto
    }

}


Func Matrix
diff_tmd00016(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix dxx;
#ifndef TMD00016_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00016_DISABLE_HALIST */
  Matrix dx, x, u;
#ifdef TMD00016_USER_DIFF
  Matrix TMD00016_USER_DIFF();
#endif /* TMD00016_USER_DIFF */
  Real Pm, theta, omega, At, Phi, Kt;

  x = chop_state_tmd00016(xx);
  u = chop_input_tmd00016(uu);

#if 0
#ifndef TMD00016_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_LIN_FLAG}) == {0}) // ǥ
#else /* TMD00016_DISABLE_HALIST */
  if (tmd00016_flag == 0) // ǥ
#endif /* ! TMD00016_DISABLE_HALIST */
    {
#endif /* 0 */
      Pm = x(1); /* Pa */	// ޥ˥ۡɶ
      theta = u(1); /* rad */	// åȥ
      omega = u(2); /* rad/s */	// 󥸥®
      At = tmd16(At0)*(1.0 - cos(theta)); /* m^2 */	// åȥ볫
      if (Pm/tmd16(P0) > 0.53)
	{
	  Phi = sqrt(2.0*tmd16(kappa)/(tmd16(kappa) - 1.0)
		     *((Pm/tmd16(P0))^(2.0/tmd16(kappa))
		       - (Pm/tmd16(P0))^((tmd16(kappa) + 1.0)/tmd16(kappa))));
	}
      else
	{
	  Phi = 0.685;
	}
      Kt = 1.0; /* */	// Kt(t): åȥή̷(not specified)

      dx = [sqrt(tmd16(R))/tmd16(Vm)*(tmd16(P0)*tmd16(Tm))/sqrt(tmd16(T0))*At/omega*Phi*Kt
	    - tmd16(Vc)/(PI*tmd16(Vm))*x(1)*(tmd16(a0) + tmd16(a1)*omega + tmd16(a2)*omega^2 + tmd16(a3)*x(1))];
#if 0
    }
  else // ǥ
    {
      // not given.
    }
#endif /* 0 */

  dxx = [[dx]
#ifdef TMD00016_USER_DIFF
	 [TMD00016_USER_DIFF(t, xx, uu)]
#endif /* TMD00016_USER_DIFF */
	 ];
  return dxx;
}


Func Matrix
output_tmd00016(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, u, y;
  Real Kc, omega, Pm;

  x = chop_state_tmd00016(xx);
  u = chop_input_tmd00016(uu);

  omega = u(2);
  Pm = x(1);
  Kc = tmd16(a0) + tmd16(a1)*omega + tmd16(a2)*omega^2 + tmd16(a3)*Pm;
  y = [Kc*omega/PI*tmd16(Vc)/(tmd16(R)*tmd16(Tm))*x(1)]';

  return y;
}

#undef tmd16
#undef _TMD_LALIST
#undef _TMD_LIN_FLAG

#endif /* !_TMD00016_MM */
